package com.qianmi.autoupdater;

import android.app.Application;
import android.util.Log;

import com.facebook.react.ReactNativeHost;
import com.facebook.react.modules.storage.AsyncLocalStorageUtil;
import com.facebook.react.modules.storage.ReactDatabaseSupplier;

import java.util.Map;

import javax.annotation.Nullable;

import static com.qianmi.autoupdater.RNRenderModule.BUNDLE_APK_URI_STORAGE_KEY;
import static com.qianmi.autoupdater.RNRenderModule.OBJECT_KEY_BUNDLE_URL;


/**
 * Created by xiayinglin on 2017/9/24.
 */
public abstract class ReloadReactNativeHost extends ReactNativeHost {


    public ReloadReactNativeHost(Application application) {
        super(application);
    }


    @Nullable
    @Override
    protected String getJSBundleFile() {
        //从asyncStroage中获取升级版本信息
        ReactDatabaseSupplier mReactDataSupplier = ReactDatabaseSupplier.getInstance(getApplication());
        String data = AsyncLocalStorageUtil.getItemImpl(mReactDataSupplier.get(), BUNDLE_APK_URI_STORAGE_KEY);
        Map<String, String> map = RNRenderModule.toData(data);
        String url = map.get(OBJECT_KEY_BUNDLE_URL);
        Log.d(getClass().getSimpleName(), "ReloadReactNativeHost.getJSBundleFile ->:" + url);
        return url;
    }


    public abstract String getPackageName();
}
